/* $Id: Hsound.java,v 1.8 2012/02/13 11:25:54 mit Exp $ */
/* Hsound.java */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class Hsound extends Applet 
    implements Runnable, AdjustmentListener, ActionListener
{
    private Scrollbar scrX;
    private Thread th;
    private Button btStop;  // stop
    private Button btGO;    // go
    private Panel PS;

    static int LEN = 64;   // Ĺ
    static int MUL = 40;   // ܲ
    static int HZ = 1;     // ȿ 
    static int FLM = LEN;      // 1ʬ
    static double DT = 2d*Math.PI/FLM;
    private static final long serialVersionUID = 1L;

    boolean SW;
    int W;
    int H;
    int H2;
    int DOT;
    int SFT;
    int CNT = 0; // 
    double Ppoint = 8.0/LEN;
    double DW;
    double DH;

    Graphics gi;
    Image ig;
    DecimalFormat df1;

    public void init() {
	setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
	setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0#");

        PS = new Panel();
        PS.setLayout(new GridLayout(2,2,0,0));

        scrX = new Scrollbar(Scrollbar.HORIZONTAL,LEN/8, 1, 1, LEN);
        PS.add(scrX);
	scrX.addAdjustmentListener(this);

        PS.add(new Label(" : Plucking Point"));

        btGO = new Button("GO");
        PS.add(btGO);
        btGO.addActionListener(this);

        btStop = new Button("Stop");
        PS.add(btStop);
        btStop.addActionListener(this);

        add(PS, "South");
    }
    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;
	H2 = H/2;
	DOT = 4;
	SFT = DOT/2;
	ig = createImage(W, H);
        gi = ig.getGraphics();

	DW = W/(double)(LEN+1);
	DH = H*4;

        if (th == null) {
            th = new Thread(this);
	    th.start();
        }
    }
    public Dimension getCanvasD() {
        Dimension ds = PS.getSize();
        Dimension da = getSize();
        int cw = da.width;
        int ch = da.height-ds.height;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void run() {
        while(!SW) {
            try {
                CNT++;
		if (CNT > Integer.MAX_VALUE)
		    CNT = 0;
		
		repaint();
                th.sleep(90);
            } 
	    catch (InterruptedException e) {
		System.out.println(e);
	    }
        }
    }
    public void stop() {
        if (th != null)
	    th = null;
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {	
	Ppoint = scrX.getValue()/(double)LEN;

	repaint();
    }
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == btStop)      // stop
            SW = true;
        else if (e.getSource() == btGO) { // go
            SW = false;
            th = null;
            start();
        }
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    //
    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
	paintI();
        g.drawImage(ig, 0, 0, this);
    }
    public void paintI() {
	gi.setColor(Color.black);
        gi.fillRect(0, 0, W, H);

	disp_line(gi);

	double[] x0 = calc_harp();

	gi.setColor(Color.magenta);
	for (int x = 0; x <= LEN; x++)         //  <= 
	    gi.fillOval((int)(DW*x+SFT), (int)(H2-DH*x0[x]), DOT, DOT);
    }
    public double[] calc_harp() {
	double[] tmp = new double[LEN+1];
	double mp, mm;

	for (int j = 1; j <= MUL; j++) {
	    mp = j*Math.PI;
	    mm = DT*CNT*j*HZ;
	    for (int x = 0; x < LEN; x++)
		tmp[x] += plucking(mp, mm, x); // z
	}

	return tmp;
    }
    public double plucking(double mp, double mm, int x) { // z
       	return 1.0/Math.pow(mp, 2) * Math.sin(mp*x/LEN) *
		Math.sin(mp*Ppoint) * Math.cos(mm);  
    }
    public void disp_line(Graphics g) {
	g.setColor(Color.gray);
        g.drawLine(0, H2+SFT, W, H2+SFT);

	g.setColor(Color.red);
	g.drawString("Plucking Point: 1/"+dform(1.0/Ppoint), 10, 20);
    }
}